﻿using System;
using System.Drawing;
using System.Configuration;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Windows;
using System.Windows.Threading;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace LayerNameTest
{
    public partial class _Default : System.Web.UI.Page
    {

        string _shapePath;
        string _shapePathName;
        string _shapeFileName;
        private Bitmap bitmap = null;
       // private PointShape mousePosition = null;
       // private DispatcherTimer highlightTimer = null;
        //private LayerOverlay highlightOverlay = null;
        protected void Page_Load(object sender, EventArgs e)
        {

            #region IsPostBack
            if (Page.IsPostBack)
            {
                ScriptManager.RegisterStartupScript(this, this.GetType(), " resizeStuff", " resizeStuff();", true);
                string ctrlname = Page.Request.Params.Get("__EVENTTARGET");

            }
            #endregion
            if (!IsPostBack)
            {
                // Set the Map Unit. The reason for setting it to DecimalDegrees is that is what the shapefile's unit of measure is inherently in.
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay("AB Adjusted Pipelines FEB");
                worldMapKitOverlay.IsBaseOverlay = false;
                worldMapKitOverlay.Name = "  AB Adjusted Pipelines FEB" + @"<IMG SRC='http://gis.thinkgeo.com/DesktopModules/ActiveForums/themes/thinkgeo/default_avatar.png' ALT='Blue'>";
                // This setting will apply from ZoonLevel01 to ZoomLevel20, that means we can see the world the same style with ZoomLevel01 all the time no matter how far we zoom out/in.
                //worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#ffffff"));     //#E5E3DF

                Map1.MapTools.OverlaySwitcher.Enabled = true;
                Map1.MapTools.OverlaySwitcher.BaseOverlayTitle = "Base overlay";
  
                _shapePath = "~/Shapefiles/";
                _shapeFileName = "cntry02.shp";
                _shapePathName = _shapePath + _shapeFileName;
                
                var layerNameOverlay = new LayerOverlay("Country layer", false, TileType.MultipleTile);
                ShapeFileFeatureLayer layerCountry = new ShapeFileFeatureLayer(MapPath(_shapePathName));
                ShapeFileFeatureLayer.BuildIndexFile(MapPath(_shapePathName));          
                
                layerCountry.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                layerCountry.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.DarkRed));
                //ll apply from ZoomLevel01 to ZoomLevel20, that means we can see city symbols the same style with ZoomLevel01 all the time no matter how far we zoom out/in.
                layerNameOverlay.Layers.Add(layerCountry);
                //layerNameOverlay.Layers.Add(
                Map1.CustomOverlays.Add(worldMapKitOverlay);
                Map1.CustomOverlays.Add(layerNameOverlay);
                Map1.MapTools.LoadingImage.Enabled = true;

                
                // TODO: The layer must be open to perform this operation
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);


            }
            

        }

        protected void Map1_ClickPopUp(object sender, MapClickedEventArgs e)
        {

            var columnName = new String[5];
            Collection<Feature> features = null;
            LayerOverlay layernameOverlay = (LayerOverlay)Map1.CustomOverlays["Country layer"];
            FeatureLayer Layer = (FeatureLayer)layernameOverlay.Layers[0];
            Layer.Open();
            features = Layer.QueryTools.GetFeaturesNearestTo(e.Position, Map1.MapUnit, 1, new[] { "CNTRY_NAME", "SOVEREIGN", "POP_CNTRY", "CURR_TYPE"});
            Layer.Close();
            columnName[0] = "CNTRY_NAME";
            columnName[1] = "SOVEREIGN";
            columnName[2] = "POP_CNTRY";
            columnName[3] = "CURR_TYPE";
           
            
            // For highlighting the clicked layer file
            var highlightTwpLayer = new InMemoryFeatureLayer();
            highlightTwpLayer.ZoomLevelSet.ZoomLevel03.DefaultAreaStyle = new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(0, GeoColor.SimpleColors.Blue))) { OutlinePen = { Color = GeoColor.StandardColors.Cyan } };
            highlightTwpLayer.ZoomLevelSet.ZoomLevel03.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            highlightTwpLayer.Open();
            highlightTwpLayer.EditTools.BeginTransaction();
            foreach (Feature hFeature in features)
             {
               highlightTwpLayer.EditTools.Add(hFeature); 
             }
            highlightTwpLayer.EditTools.CommitTransaction();
            highlightTwpLayer.Close();
            //Remove existing Overlay
            if (Map1.CustomOverlays.Contains("HighlightTWPLayer"))
            {
                Map1.CustomOverlays.Remove("HighlightTWPLayer");
            } 
            LayerOverlay highlightTwpOverlay = new LayerOverlay("HighlightTWPLayer"){ IsBaseOverlay = false, IsVisibleInOverlaySwitcher = false };
            //Add content to the click based pop ups
            if (features != null && features.Count == 0)
                return;
            var popUpText = "";
            var i = 0;
            if (Map1.Popups.Count != 0)
                Map1.Popups.Remove("oslPopUP");
            if (features != null)
            {
                foreach (var feature in features)
                {

                        while (columnName[i] != null)
                        {
                            popUpText += columnName[i] + ": " + feature.ColumnValues[columnName[i++]].ToString() + "<br />";

                        }
                        
                        PointShape Position = feature.GetBoundingBox().GetCenterPoint();

                        var oslPopUp = new CloudPopup("oslPopUP", e.Position, popUpText) { AutoPan = false, AutoSize = true, HasCloseButton = true };
                        Map1.Popups.Add(oslPopUp);
                 
                } 
            }
            
            highlightTwpOverlay.Layers.Add(highlightTwpLayer);
            Map1.CustomOverlays.Add(highlightTwpOverlay);
            

        }
    }
     
   
}